LibreOffice: rtl/string.h File Reference

LibreOffice LibreOffice 24.2 SDK C/C++ API Reference

Loading...
Searching...
No Matches
Macros | Functions
string.h File Reference
`#include "sal/config.h"`
`#include "osl/interlck.h"`
`#include "rtl/textcvt.h"`
`#include "sal/saldllapi.h"`
`#include "sal/types.h"`

Go to the source code of this file.

## Macros
#define | RTL_STR_MAX_VALUEOFBOOLEAN 6
#define | RTL_STR_MAX_VALUEOFCHAR 2
#define | RTL_STR_MIN_RADIX 2
#define | RTL_STR_MAX_RADIX 36
#define | RTL_STR_MAX_VALUEOFINT32 33
#define | RTL_STR_MAX_VALUEOFINT64 65
#define | RTL_STR_MAX_VALUEOFUINT64 65
#define | RTL_STR_MAX_VALUEOFFLOAT 15
#define | RTL_STR_MAX_VALUEOFDOUBLE 25
#define | RTL_CONSTASCII_STRINGPARAM(constAsciiStr)
| Supply an ASCII string literal together with its length.
#define | RTL_CONSTASCII_LENGTH(constAsciiStr)
| Supply the length of an ASCII string literal.
#define | OUSTRING_TO_OSTRING_CVTFLAGS

## Functions
SAL_DLLPUBLIC sal_Int32 | rtl_str_getLength (const char *str) SAL_THROW_EXTERN_C()
| Return the length of a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_compare (const char *first, const char *second) SAL_THROW_EXTERN_C()
| Compare two strings.
SAL_DLLPUBLIC sal_Int32 | rtl_str_compare_WithLength (const char *first, sal_Int32 firstLen, const char *second, sal_Int32 secondLen) SAL_THROW_EXTERN_C()
| Compare two strings.
SAL_DLLPUBLIC sal_Int32 | rtl_str_shortenedCompare_WithLength (const char *first, sal_Int32 firstLen, const char *second, sal_Int32 secondLen, sal_Int32 shortenedLen) SAL_THROW_EXTERN_C()
| Compare two strings with a maximum count of characters.
SAL_DLLPUBLIC sal_Int32 | rtl_str_reverseCompare_WithLength (const char *first, sal_Int32 firstLen, const char *second, sal_Int32 secondLen) SAL_THROW_EXTERN_C()
| Compare two strings from back to front.
SAL_DLLPUBLIC sal_Int32 | rtl_str_compareIgnoreAsciiCase (const char *first, const char *second) SAL_THROW_EXTERN_C()
| Compare two strings, ignoring the case of ASCII characters.
SAL_DLLPUBLIC sal_Int32 | rtl_str_compareIgnoreAsciiCase_WithLength (const char *first, sal_Int32 firstLen, const char *second, sal_Int32 secondLen) SAL_THROW_EXTERN_C()
| Compare two strings, ignoring the case of ASCII characters.
SAL_DLLPUBLIC sal_Int32 | rtl_str_shortenedCompareIgnoreAsciiCase_WithLength (const char *first, sal_Int32 firstLen, const char *second, sal_Int32 secondLen, sal_Int32 shortenedLen) SAL_THROW_EXTERN_C()
| Compare two strings with a maximum count of characters, ignoring the case of ASCII characters.
SAL_DLLPUBLIC sal_Int32 | rtl_str_hashCode (const char *str) SAL_THROW_EXTERN_C()
| Return a hash code for a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_hashCode_WithLength (const char *str, sal_Int32 len) SAL_THROW_EXTERN_C()
| Return a hash code for a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_indexOfChar (const char *str, char ch) SAL_THROW_EXTERN_C()
| Search for the first occurrence of a character within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_indexOfChar_WithLength (const char *str, sal_Int32 len, char ch) SAL_THROW_EXTERN_C()
| Search for the first occurrence of a character within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_lastIndexOfChar (const char *str, char ch) SAL_THROW_EXTERN_C()
| Search for the last occurrence of a character within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_lastIndexOfChar_WithLength (const char *str, sal_Int32 len, char ch) SAL_THROW_EXTERN_C()
| Search for the last occurrence of a character within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_indexOfStr (const char *str, const char *subStr) SAL_THROW_EXTERN_C()
| Search for the first occurrence of a substring within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_indexOfStr_WithLength (const char *str, sal_Int32 len, const char *subStr, sal_Int32 subLen) SAL_THROW_EXTERN_C()
| Search for the first occurrence of a substring within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_lastIndexOfStr (const char *str, const char *subStr) SAL_THROW_EXTERN_C()
| Search for the last occurrence of a substring within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_lastIndexOfStr_WithLength (const char *str, sal_Int32 len, const char *subStr, sal_Int32 subLen) SAL_THROW_EXTERN_C()
| Search for the last occurrence of a substring within a string.
SAL_DLLPUBLIC void | rtl_str_replaceChar (char *str, char oldChar, char newChar) SAL_THROW_EXTERN_C()
| Replace all occurrences of a single character within a string.
SAL_DLLPUBLIC void | rtl_str_replaceChar_WithLength (char *str, sal_Int32 len, char oldChar, char newChar) SAL_THROW_EXTERN_C()
| Replace all occurrences of a single character within a string.
SAL_DLLPUBLIC void | rtl_str_toAsciiLowerCase (char *str) SAL_THROW_EXTERN_C()
| Convert all ASCII uppercase letters to lowercase within a string.
SAL_DLLPUBLIC void | rtl_str_toAsciiLowerCase_WithLength (char *str, sal_Int32 len) SAL_THROW_EXTERN_C()
| Convert all ASCII uppercase letters to lowercase within a string.
SAL_DLLPUBLIC void | rtl_str_toAsciiUpperCase (char *str) SAL_THROW_EXTERN_C()
| Convert all ASCII lowercase letters to uppercase within a string.
SAL_DLLPUBLIC void | rtl_str_toAsciiUpperCase_WithLength (char *str, sal_Int32 len) SAL_THROW_EXTERN_C()
| Convert all ASCII lowercase letters to uppercase within a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_trim (char *str) SAL_THROW_EXTERN_C()
| Remove white space from both ends of a string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_trim_WithLength (char *str, sal_Int32 len) SAL_THROW_EXTERN_C()
| Remove white space from both ends of the string.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfBoolean (char *str, sal_Bool b) SAL_THROW_EXTERN_C()
| Create the string representation of a boolean.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfChar (char *str, char ch) SAL_THROW_EXTERN_C()
| Create the string representation of a character.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfInt32 (char *str, sal_Int32 i, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Create the string representation of an integer.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfInt64 (char *str, sal_Int64 l, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Create the string representation of a long integer.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfUInt64 (char *str, sal_uInt64 l, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Create the string representation of an unsigned long integer.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfFloat (char *str, float f) SAL_THROW_EXTERN_C()
| Create the string representation of a float.
SAL_DLLPUBLIC sal_Int32 | rtl_str_valueOfDouble (char *str, double d) SAL_THROW_EXTERN_C()
| Create the string representation of a double.
SAL_DLLPUBLIC sal_Bool | rtl_str_toBoolean (const char *str) SAL_THROW_EXTERN_C()
| Interpret a string as a boolean.
SAL_DLLPUBLIC sal_Int32 | rtl_str_toInt32 (const char *str, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Interpret a string as an integer.
SAL_DLLPUBLIC sal_uInt32 | rtl_str_toUInt32 (const char *str, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Interpret a string as an unsigned integer.
SAL_DLLPUBLIC sal_Int64 | rtl_str_toInt64 (const char *str, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Interpret a string as a long integer.
SAL_DLLPUBLIC sal_Int64 | rtl_str_toInt64_WithLength (const char *str, sal_Int16 radix, sal_Int32 nStrLength) SAL_THROW_EXTERN_C()
| Interpret a string as a long integer.
SAL_DLLPUBLIC sal_uInt64 | rtl_str_toUInt64 (const char *str, sal_Int16 radix) SAL_THROW_EXTERN_C()
| Interpret a string as an unsigned long integer.
SAL_DLLPUBLIC float | rtl_str_toFloat (const char *str) SAL_THROW_EXTERN_C()
| Interpret a string as a float.
SAL_DLLPUBLIC double | rtl_str_toDouble (const char *str) SAL_THROW_EXTERN_C()
| Interpret a string as a double.
SAL_DLLPUBLIC void | rtl_string_acquire (rtl_String *str) SAL_THROW_EXTERN_C()
| Increment the reference count of a string.
SAL_DLLPUBLIC void | rtl_string_release (rtl_String *str) SAL_THROW_EXTERN_C()
| Decrement the reference count of a string.
SAL_DLLPUBLIC void | rtl_string_new (rtl_String **newStr) SAL_THROW_EXTERN_C()
| Allocate a new string containing no characters.
SAL_DLLPUBLIC rtl_String * | rtl_string_alloc (sal_Int32 nLen) SAL_THROW_EXTERN_C()
| Allocate a new string containing space for a given number of characters.
SAL_DLLPUBLIC void | rtl_string_new_WithLength (rtl_String **newStr, sal_Int32 len) SAL_THROW_EXTERN_C()
| Allocate a new string containing space for a given number of characters.
SAL_DLLPUBLIC void | rtl_string_newFromString (rtl_String **newStr, const rtl_String *value) SAL_THROW_EXTERN_C()
| Allocate a new string that contains a copy of another string.
SAL_DLLPUBLIC void | rtl_string_newFromStr (rtl_String **newStr, const char *value) SAL_THROW_EXTERN_C()
| Allocate a new string that contains a copy of a character array.
SAL_DLLPUBLIC void | rtl_string_newFromStr_WithLength (rtl_String **newStr, const char *value, sal_Int32 len) SAL_THROW_EXTERN_C()
| Allocate a new string that contains a copy of a character array.
SAL_DLLPUBLIC void | rtl_string_newFromSubString (rtl_String **newStr, const rtl_String *from, sal_Int32 beginIndex, sal_Int32 count) SAL_THROW_EXTERN_C()
| Allocate a new string that is a substring of this string.
SAL_DLLPUBLIC void | rtl_string_newFromLiteral (rtl_String **newStr, const char *value, sal_Int32 len, sal_Int32 allocExtra) SAL_THROW_EXTERN_C()
SAL_DLLPUBLIC void | rtl_string_assign (rtl_String **str, rtl_String *rightValue) SAL_THROW_EXTERN_C()
| Assign a new value to a string.
SAL_DLLPUBLIC sal_Int32 | rtl_string_getLength (const rtl_String *str) SAL_THROW_EXTERN_C()
| Return the length of a string.
SAL_DLLPUBLIC char * | rtl_string_getStr (rtl_String *str) SAL_THROW_EXTERN_C()
| Return a pointer to the underlying character array of a string.
SAL_DLLPUBLIC void | rtl_string_newConcat (rtl_String **newStr, rtl_String *left, rtl_String *right) SAL_THROW_EXTERN_C()
| Create a new string that is the concatenation of two other strings.
SAL_DLLPUBLIC void | rtl_string_newReplaceStrAt (rtl_String **newStr, rtl_String *str, sal_Int32 idx, sal_Int32 count, rtl_String *subStr) SAL_THROW_EXTERN_C()
| Create a new string by replacing a substring of another string.
SAL_DLLPUBLIC void | rtl_string_newReplace (rtl_String **newStr, rtl_String *str, char oldChar, char newChar) SAL_THROW_EXTERN_C()
| Create a new string by replacing all occurrences of a single character within another string.
SAL_DLLPUBLIC void | rtl_string_newReplaceFirst (rtl_String **newStr, rtl_String *str, char const *from, sal_Int32 fromLength, char const *to, sal_Int32 toLength, sal_Int32 *index) SAL_THROW_EXTERN_C()
| Create a new string by replacing the first occurrence of a given substring with another substring.
SAL_DLLPUBLIC void | rtl_string_newReplaceAll (rtl_String **newStr, rtl_String *str, char const *from, sal_Int32 fromLength, char const *to, sal_Int32 toLength) SAL_THROW_EXTERN_C()
| Create a new string by replacing all occurrences of a given substring with another substring.
SAL_DLLPUBLIC void | rtl_string_newToAsciiLowerCase (rtl_String **newStr, rtl_String *str) SAL_THROW_EXTERN_C()
| Create a new string by converting all ASCII uppercase letters to lowercase within another string.
SAL_DLLPUBLIC void | rtl_string_newToAsciiUpperCase (rtl_String **newStr, rtl_String *str) SAL_THROW_EXTERN_C()
| Create a new string by converting all ASCII lowercase letters to uppercase within another string.
SAL_DLLPUBLIC void | rtl_string_newTrim (rtl_String **newStr, rtl_String *str) SAL_THROW_EXTERN_C()
| Create a new string by removing white space from both ends of another string.
SAL_DLLPUBLIC sal_Int32 | rtl_string_getToken (rtl_String **newStr, rtl_String *str, sal_Int32 token, char cTok, sal_Int32 idx) SAL_THROW_EXTERN_C()
| Create a new string by extracting a single token from another string.
SAL_DLLPUBLIC void | rtl_uString2String (rtl_String **newStr, const sal_Unicode *str, sal_Int32 len, rtl_TextEncoding encoding, sal_uInt32 convertFlags) SAL_THROW_EXTERN_C()
| Create a new byte string by converting a Unicode string, using a specific text encoding.
SAL_DLLPUBLIC sal_Bool | rtl_convertUStringToString (rtl_String **pTarget, sal_Unicode const *pSource, sal_Int32 nLength, rtl_TextEncoding nEncoding, sal_uInt32 nFlags) SAL_THROW_EXTERN_C()
| Converts a Unicode string to a byte string, signalling failure.
SAL_DLLPUBLIC void | rtl_string_ensureCapacity (rtl_String **str, sal_Int32 size) SAL_THROW_EXTERN_C()
| Ensure a string has enough space for a given number of characters.

## Macro Definition Documentation

## ◆ OUSTRING_TO_OSTRING_CVTFLAGS

#define OUSTRING_TO_OSTRING_CVTFLAGS

Value:
(RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT |\
RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT |\
RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE |\
RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0)
RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0
#define RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0
Definition textcvt.h:159
RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT
#define RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT
Definition textcvt.h:150
RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE
#define RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE
Definition textcvt.h:157
RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT
#define RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT
Definition textcvt.h:156

## ◆ RTL_CONSTASCII_LENGTH

#define RTL_CONSTASCII_LENGTH | ( |  | constAsciiStr | ) |

Value:
((sal_Int32)(SAL_N_ELEMENTS(constAsciiStr)-1))
SAL_N_ELEMENTS
#define SAL_N_ELEMENTS(arr)
Definition macros.h:51

Supply the length of an ASCII string literal.

This macro can be used to compute arguments in function calls like rtl::OUString::match(other, RTL_CONSTASCII_LENGTH("prefix")).

Parameters

  constAsciiStr | must be an expression of type "(possibly cv-qualified reference to) array of (possibly cv-qualified) char." Each element of the referenced array must represent an ASCII value in the range 0x00–0x7F. The last element of the referenced array is not considered part of the represented ASCII string, and its value should be 0x00. Depending on where this macro is used, the nature of the supplied expression might be further restricted.

## ◆ RTL_CONSTASCII_STRINGPARAM

#define RTL_CONSTASCII_STRINGPARAM | ( |  | constAsciiStr | ) |

Value:
(&(constAsciiStr)[0]), \
((sal_Int32)SAL_N_ELEMENTS(constAsciiStr)-1)

Supply an ASCII string literal together with its length.

This macro can be used to compute (some of) the arguments in function calls like rtl::OString(RTL_CONSTASCII_STRINGPARAM("foo")) or rtl::OUString::equalsAsciiL(RTL_CONSTASCII_STRINGPARAM("foo")).

Parameters

  constAsciiStr | must be an expression of type "(possibly cv-qualified reference to) array of (possibly cv-qualified) char." Each element of the referenced array must represent an ASCII value in the range 0x00–0x7F. The last element of the referenced array is not considered part of the represented ASCII string, and its value should be 0x00. Depending on where this macro is used, the nature of the supplied expression might be further restricted.

## ◆ RTL_STR_MAX_RADIX

#define RTL_STR_MAX_RADIX 36

## ◆ RTL_STR_MAX_VALUEOFBOOLEAN

#define RTL_STR_MAX_VALUEOFBOOLEAN 6

## ◆ RTL_STR_MAX_VALUEOFCHAR

#define RTL_STR_MAX_VALUEOFCHAR 2

## ◆ RTL_STR_MAX_VALUEOFDOUBLE

#define RTL_STR_MAX_VALUEOFDOUBLE 25

## ◆ RTL_STR_MAX_VALUEOFFLOAT

#define RTL_STR_MAX_VALUEOFFLOAT 15

## ◆ RTL_STR_MAX_VALUEOFINT32

#define RTL_STR_MAX_VALUEOFINT32 33

## ◆ RTL_STR_MAX_VALUEOFINT64

#define RTL_STR_MAX_VALUEOFINT64 65

## ◆ RTL_STR_MAX_VALUEOFUINT64

#define RTL_STR_MAX_VALUEOFUINT64 65

## ◆ RTL_STR_MIN_RADIX

#define RTL_STR_MIN_RADIX 2

## Function Documentation

## ◆ rtl_convertUStringToString()

SAL_DLLPUBLIC sal_Bool rtl_convertUStringToString | ( | rtl_String ** | pTarget,
|  | sal_Unicode const * | pSource,
|  | sal_Int32 | nLength,
|  | rtl_TextEncoding | nEncoding,
|  | sal_uInt32 | nFlags )

Converts a Unicode string to a byte string, signalling failure.

Parameters

  pTarget | An out parameter receiving the converted string. Must not be null itself, and must contain either null or a pointer to a valid rtl_String; the contents are not modified if conversion fails (rtl_convertUStringToString returns false).
  pSource | The Unicode string. May only be null if nLength is zero.
  nLength | The length of the Unicode string. Must be non-negative.
  nEncoding | The text encoding to convert into. Must be an octet encoding (i.e., rtl_isOctetTextEncoding(nEncoding) must return true).
  nFlags | A combination of RTL_UNICODETOTEXT_FLAGS that detail how to do the conversion (see rtl_convertUnicodeToText). RTL_UNICODETOTEXT_FLAGS_FLUSH need not be included, it is implicitly assumed. Typical uses are either RTL_UNICODETOTEXT_FLAGS_UNDEFINED_ERROR | RTL_UNICODETOTEXT_FLAGS_INVALID_ERROR (fail if a Unicode character cannot be converted to the target nEncoding) or OUSTRING_TO_OSTRING_CVTFLAGS (make a best efforts conversion).

Returns
  True if the conversion succeeded, false otherwise.

## ◆ rtl_str_compare()

SAL_DLLPUBLIC sal_Int32 rtl_str_compare | ( | const char * | first,
|  | const char * | second )

Compare two strings.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. This function cannot be used for language-specific sorting. Both strings must be null-terminated.

Parameters

  first | the first null-terminated string to be compared.
  second | the second null-terminated string which is compared with the first one.

Returns
  0 if both strings are equal, a value less than 0 if the first string is less than the second string, and a value greater than 0 if the first string is greater than the second string.

## ◆ rtl_str_compare_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_compare_WithLength | ( | const char * | first,
|  | sal_Int32 | firstLen,
|  | const char * | second,
|  | sal_Int32 | secondLen )

Compare two strings.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. This function cannot be used for language-specific sorting.

Parameters

  first | the first string to be compared. Need not be null-terminated, but must be at least as long as the specified firstLen.
  firstLen | the length of the first string.
  second | the second string which is compared with the first one. Need not be null-terminated, but must be at least as long as the specified secondLen.
  secondLen | the length of the second string.

Returns
  0 if both strings are equal, a value less than 0 if the first string is less than the second string, and a value greater than 0 if the first string is greater than the second string.

## ◆ rtl_str_compareIgnoreAsciiCase()

SAL_DLLPUBLIC sal_Int32 rtl_str_compareIgnoreAsciiCase | ( | const char * | first,
|  | const char * | second )

Compare two strings, ignoring the case of ASCII characters.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. Character values between 65 and 90 (ASCII A–Z) are interpreted as values between 97 and 122 (ASCII a–z). This function cannot be used for language-specific sorting. Both strings must be null-terminated.

Parameters

  first | the first null-terminated string to be compared.
  second | the second null-terminated string which is compared with the first one.

Returns
  0 if both strings are equal, a value less than 0 if the first string is less than the second string, and a value greater than 0 if the first string is greater than the second string.

## ◆ rtl_str_compareIgnoreAsciiCase_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_compareIgnoreAsciiCase_WithLength | ( | const char * | first,
|  | sal_Int32 | firstLen,
|  | const char * | second,
|  | sal_Int32 | secondLen )

Compare two strings, ignoring the case of ASCII characters.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. Character values between 65 and 90 (ASCII A–Z) are interpreted as values between 97 and 122 (ASCII a–z). This function cannot be used for language-specific sorting.

Parameters

  first | the first string to be compared. Need not be null-terminated, but must be at least as long as the specified firstLen.
  firstLen | the length of the first string.
  second | the second string which is compared with the first one. Need not be null-terminated, but must be at least as long as the specified secondLen.
  secondLen | the length of the second string.

Returns
  0 if both strings are equal, a value less than 0 if the first string is less than the second string, and a value greater than 0 if the first string is greater than the second string.

## ◆ rtl_str_getLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_getLength | ( | const char * | str | ) |

Return the length of a string.

The length is equal to the number of 8-bit characters in the string, without the terminating NUL character.

Parameters

  str | a null-terminated string.

Returns
  the length of the sequence of characters represented by this string, excluding the terminating NUL character.

## ◆ rtl_str_hashCode()

SAL_DLLPUBLIC sal_Int32 rtl_str_hashCode | ( | const char * | str | ) |

Return a hash code for a string.

It is not allowed to store the hash code persistently, because later versions could return other hash codes. The string must be null-terminated.

Parameters

  str | a null-terminated string.

Returns
  a hash code for the given string.

## ◆ rtl_str_hashCode_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_hashCode_WithLength | ( | const char * | str,
|  | sal_Int32 | len )

Return a hash code for a string.

It is not allowed to store the hash code persistently, because later versions could return other hash codes.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.

Returns
  a hash code for the given string.

## ◆ rtl_str_indexOfChar()

SAL_DLLPUBLIC sal_Int32 rtl_str_indexOfChar | ( | const char * | str,
|  | char | ch )

Search for the first occurrence of a character within a string.

The string must be null-terminated.

Parameters

  str | a null-terminated string.
  ch | the character to be searched for.

Returns
  the index (starting at 0) of the first occurrence of the character in the string, or -1 if the character does not occur.

## ◆ rtl_str_indexOfChar_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_indexOfChar_WithLength | ( | const char * | str,
|  | sal_Int32 | len,
|  | char | ch )

Search for the first occurrence of a character within a string.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.
  ch | the character to be searched for.

Returns
  the index (starting at 0) of the first occurrence of the character in the string, or -1 if the character does not occur.

## ◆ rtl_str_indexOfStr()

SAL_DLLPUBLIC sal_Int32 rtl_str_indexOfStr | ( | const char * | str,
|  | const char * | subStr )

Search for the first occurrence of a substring within a string.

If subStr is empty, or both str and subStr are empty, -1 is returned. Both strings must be null-terminated.

Parameters

  str | a null-terminated string.
  subStr | the null-terminated substring to be searched for.

Returns
  the index (starting at 0) of the first character of the first occurrence of the substring within the string, or -1 if the substring does not occur.

## ◆ rtl_str_indexOfStr_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_indexOfStr_WithLength | ( | const char * | str,
|  | sal_Int32 | len,
|  | const char * | subStr,
|  | sal_Int32 | subLen )

Search for the first occurrence of a substring within a string.

If subStr is empty, or both str and subStr are empty, -1 is returned.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.
  subStr | the substring to be searched for. Need not be null-terminated, but must be at least as long as the specified subLen.
  subLen | the length of the substring.

Returns
  the index (starting at 0) of the first character of the first occurrence of the substring within the string, or -1 if the substring does not occur.

## ◆ rtl_str_lastIndexOfChar()

SAL_DLLPUBLIC sal_Int32 rtl_str_lastIndexOfChar | ( | const char * | str,
|  | char | ch )

Search for the last occurrence of a character within a string.

The string must be null-terminated.

Parameters

  str | a null-terminated string.
  ch | the character to be searched for.

Returns
  the index (starting at 0) of the last occurrence of the character in the string, or -1 if the character does not occur. The returned value is always smaller than the string length.

## ◆ rtl_str_lastIndexOfChar_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_lastIndexOfChar_WithLength | ( | const char * | str,
|  | sal_Int32 | len,
|  | char | ch )

Search for the last occurrence of a character within a string.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.
  ch | the character to be searched for.

Returns
  the index (starting at 0) of the last occurrence of the character in the string, or -1 if the character does not occur. The returned value is always smaller than the string length.

## ◆ rtl_str_lastIndexOfStr()

SAL_DLLPUBLIC sal_Int32 rtl_str_lastIndexOfStr | ( | const char * | str,
|  | const char * | subStr )

Search for the last occurrence of a substring within a string.

If subStr is empty, or both str and subStr are empty, -1 is returned. Both strings must be null-terminated.

Parameters

  str | a null-terminated string.
  subStr | the null-terminated substring to be searched for.

Returns
  the index (starting at 0) of the first character of the last occurrence of the substring within the string, or -1 if the substring does not occur.

## ◆ rtl_str_lastIndexOfStr_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_lastIndexOfStr_WithLength | ( | const char * | str,
|  | sal_Int32 | len,
|  | const char * | subStr,
|  | sal_Int32 | subLen )

Search for the last occurrence of a substring within a string.

If subStr is empty, or both str and subStr are empty, -1 is returned.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.
  subStr | the substring to be searched for. Need not be null-terminated, but must be at least as long as the specified subLen.
  subLen | the length of the substring.

Returns
  the index (starting at 0) of the first character of the first occurrence of the substring within the string, or -1 if the substring does not occur.

## ◆ rtl_str_replaceChar()

SAL_DLLPUBLIC void rtl_str_replaceChar | ( | char * | str,
|  | char | oldChar,
|  | char | newChar )

Replace all occurrences of a single character within a string.

If oldChar does not occur within str, then the string is not modified. The string must be null-terminated.

Parameters

  str | a null-terminated string.
  oldChar | the old character.
  newChar | the new character.

## ◆ rtl_str_replaceChar_WithLength()

SAL_DLLPUBLIC void rtl_str_replaceChar_WithLength | ( | char * | str,
|  | sal_Int32 | len,
|  | char | oldChar,
|  | char | newChar )

Replace all occurrences of a single character within a string.

If oldChar does not occur within str, then the string is not modified.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.
  oldChar | the old character.
  newChar | the new character.

## ◆ rtl_str_reverseCompare_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_reverseCompare_WithLength | ( | const char * | first,
|  | sal_Int32 | firstLen,
|  | const char * | second,
|  | sal_Int32 | secondLen )

Compare two strings from back to front.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. This function cannot be used for language-specific sorting.

Parameters

  first | the first string to be compared. Need not be null-terminated, but must be at least as long as the specified firstLen.
  firstLen | the length of the first string.
  second | the second string which is compared with the first one. Need not be null-terminated, but must be at least as long as the specified secondLen.
  secondLen | the length of the second string.

Returns
  0 if both strings are equal, a value less than 0 if the first string compares less than the second string, and a value greater than 0 if the first string compares greater than the second string.

## ◆ rtl_str_shortenedCompare_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_shortenedCompare_WithLength | ( | const char * | first,
|  | sal_Int32 | firstLen,
|  | const char * | second,
|  | sal_Int32 | secondLen,
|  | sal_Int32 | shortenedLen )

Compare two strings with a maximum count of characters.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. This function cannot be used for language-specific sorting.

Parameters

  first | the first string to be compared. Need not be null-terminated, but must be at least as long as the specified firstLen.
  firstLen | the length of the first string.
  second | the second string which is compared with the first one. Need not be null-terminated, but must be at least as long as the specified secondLen.
  secondLen | the length of the second string.
  shortenedLen | the maximum number of characters to compare. This length can be greater or smaller than the lengths of the two strings.

Returns
  0 if both substrings are equal, a value less than 0 if the first substring is less than the second substring, and a value greater than 0 if the first substring is greater than the second substring.

## ◆ rtl_str_shortenedCompareIgnoreAsciiCase_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_shortenedCompareIgnoreAsciiCase_WithLength | ( | const char * | first,
|  | sal_Int32 | firstLen,
|  | const char * | second,
|  | sal_Int32 | secondLen,
|  | sal_Int32 | shortenedLen )

Compare two strings with a maximum count of characters, ignoring the case of ASCII characters.

The comparison is based on the numeric value of each character in the strings and returns a value indicating their relationship. Character values between 65 and 90 (ASCII A–Z) are interpreted as values between 97 and 122 (ASCII a–z). This function cannot be used for language-specific sorting.

Parameters

  first | the first string to be compared. Need not be null-terminated, but must be at least as long as the specified firstLen.
  firstLen | the length of the first string.
  second | the second string which is compared with the first one. Need not be null-terminated, but must be at least as long as the specified secondLen.
  secondLen | the length of the second string.
  shortenedLen | the maximum number of characters to compare. This length can be greater or smaller than the lengths of the two strings.

Returns
  0 if both substrings are equal, a value less than 0 if the first substring is less than the second substring, and a value greater than 0 if the first substring is greater than the second substring.

## ◆ rtl_str_toAsciiLowerCase()

SAL_DLLPUBLIC void rtl_str_toAsciiLowerCase | ( | char * | str | ) |

Convert all ASCII uppercase letters to lowercase within a string.

The characters with values between 65 and 90 (ASCII A–Z) are replaced with values between 97 and 122 (ASCII a–z). The string must be null-terminated.

Parameters

  str | a null-terminated string.

## ◆ rtl_str_toAsciiLowerCase_WithLength()

SAL_DLLPUBLIC void rtl_str_toAsciiLowerCase_WithLength | ( | char * | str,
|  | sal_Int32 | len )

Convert all ASCII uppercase letters to lowercase within a string.

The characters with values between 65 and 90 (ASCII A–Z) are replaced with values between 97 and 122 (ASCII a–z).

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.

## ◆ rtl_str_toAsciiUpperCase()

SAL_DLLPUBLIC void rtl_str_toAsciiUpperCase | ( | char * | str | ) |

Convert all ASCII lowercase letters to uppercase within a string.

The characters with values between 97 and 122 (ASCII a–z) are replaced with values between 65 and 90 (ASCII A–Z). The string must be null-terminated.

Parameters

  str | a null-terminated string.

## ◆ rtl_str_toAsciiUpperCase_WithLength()

SAL_DLLPUBLIC void rtl_str_toAsciiUpperCase_WithLength | ( | char * | str,
|  | sal_Int32 | len )

Convert all ASCII lowercase letters to uppercase within a string.

The characters with values between 97 and 122 (ASCII a–z) are replaced with values between 65 and 90 (ASCII A–Z).

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the string.

## ◆ rtl_str_toBoolean()

SAL_DLLPUBLIC sal_Bool rtl_str_toBoolean | ( | const char * | str | ) |

Interpret a string as a boolean.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.

Returns
  true if the string is "1" or "true" in any ASCII case, false otherwise.

## ◆ rtl_str_toDouble()

SAL_DLLPUBLIC double rtl_str_toDouble | ( | const char * | str | ) |

Interpret a string as a double.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.

Returns
  the float value represented by the string, or 0.0 if the string does not represent a double.

## ◆ rtl_str_toFloat()

SAL_DLLPUBLIC float rtl_str_toFloat | ( | const char * | str | ) |

Interpret a string as a float.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.

Returns
  the float value represented by the string, or 0.0 if the string does not represent a float.

## ◆ rtl_str_toInt32()

SAL_DLLPUBLIC sal_Int32 rtl_str_toInt32 | ( | const char * | str,
|  | sal_Int16 | radix )

Interpret a string as an integer.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.

Returns
  the integer value represented by the string, or 0 if the string does not represent an integer.

## ◆ rtl_str_toInt64()

SAL_DLLPUBLIC sal_Int64 rtl_str_toInt64 | ( | const char * | str,
|  | sal_Int16 | radix )

Interpret a string as a long integer.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.

Returns
  the long integer value represented by the string, or 0 if the string does not represent a long integer.

## ◆ rtl_str_toInt64_WithLength()

SAL_DLLPUBLIC sal_Int64 rtl_str_toInt64_WithLength | ( | const char * | str,
|  | sal_Int16 | radix,
|  | sal_Int32 | nStrLength )

Interpret a string as a long integer.

This function cannot be used for language-specific conversion.

Parameters

  str | a string.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.
  nStrLength | number of chars to process

Returns
  the long integer value represented by the string, or 0 if the string does not represent a long integer.

## ◆ rtl_str_toUInt32()

SAL_DLLPUBLIC sal_uInt32 rtl_str_toUInt32 | ( | const char * | str,
|  | sal_Int16 | radix )

Interpret a string as an unsigned integer.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.
  radix | the radix. Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX (36), inclusive.

Returns
  the unsigned integer value represented by the string, or 0 if the string does not represent an unsigned integer.

Since
  LibreOffice 4.2

## ◆ rtl_str_toUInt64()

SAL_DLLPUBLIC sal_uInt64 rtl_str_toUInt64 | ( | const char * | str,
|  | sal_Int16 | radix )

Interpret a string as an unsigned long integer.

This function cannot be used for language-specific conversion. The string must be null-terminated.

Parameters

  str | a null-terminated string.
  radix | the radix. Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX (36), inclusive.

Returns
  the unsigned long integer value represented by the string, or 0 if the string does not represent an unsigned long integer.

Since
  LibreOffice 4.1

## ◆ rtl_str_trim()

SAL_DLLPUBLIC sal_Int32 rtl_str_trim | ( | char * | str | ) |

Remove white space from both ends of a string.

All characters with values less than or equal to 32 (the space character) are considered to be white space. This function cannot be used for language-specific operations. The string must be null-terminated.

Parameters

  str | a null-terminated string.

Returns
  the new length of the string.

## ◆ rtl_str_trim_WithLength()

SAL_DLLPUBLIC sal_Int32 rtl_str_trim_WithLength | ( | char * | str,
|  | sal_Int32 | len )

Remove white space from both ends of the string.

All characters with values less than or equal to 32 (the space character) are considered to be white space. This function cannot be used for language-specific operations. The string must be null-terminated.

Parameters

  str | a string. Need not be null-terminated, but must be at least as long as the specified len.
  len | the original length of the string.

Returns
  the new length of the string.

## ◆ rtl_str_valueOfBoolean()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfBoolean | ( | char * | str,
|  | sal_Bool | b )

Create the string representation of a boolean.

If b is true, the buffer is filled with the string "true" and 4 is returned. If b is false, the buffer is filled with the string "false" and 5 is returned. This function cannot be used for language-specific operations.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFBOOLEAN define to create a buffer that is big enough.
  b | a boolean value.

Returns
  the length of the string.

## ◆ rtl_str_valueOfChar()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfChar | ( | char * | str,
|  | char | ch )

Create the string representation of a character.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFCHAR define to create a buffer that is big enough.
  ch | a character value.

Returns
  the length of the string.

## ◆ rtl_str_valueOfDouble()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfDouble | ( | char * | str,
|  | double | d )

Create the string representation of a double.

This function cannot be used for language-specific conversion.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFDOUBLE define to create a buffer that is big enough.
  d | a double value.

Returns
  the length of the string.

## ◆ rtl_str_valueOfFloat()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfFloat | ( | char * | str,
|  | float | f )

Create the string representation of a float.

This function cannot be used for language-specific conversion.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFFLOAT define to create a buffer that is big enough.
  f | a float value.

Returns
  the length of the string.

## ◆ rtl_str_valueOfInt32()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfInt32 | ( | char * | str,
|  | sal_Int32 | i,
|  | sal_Int16 | radix )

Create the string representation of an integer.

This function cannot be used for language-specific operations.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFINT32 define to create a buffer that is big enough.
  i | an integer value.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.

Returns
  the length of the string.

## ◆ rtl_str_valueOfInt64()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfInt64 | ( | char * | str,
|  | sal_Int64 | l,
|  | sal_Int16 | radix )

Create the string representation of a long integer.

This function cannot be used for language-specific operations.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFINT64 define to create a buffer that is big enough.
  l | a long integer value.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.

Returns
  the length of the string.

## ◆ rtl_str_valueOfUInt64()

SAL_DLLPUBLIC sal_Int32 rtl_str_valueOfUInt64 | ( | char * | str,
|  | sal_uInt64 | l,
|  | sal_Int16 | radix )

Create the string representation of an unsigned long integer.

This function cannot be used for language-specific operations.

Parameters

  str | a buffer that is big enough to hold the result and the terminating NUL character. You should use the RTL_STR_MAX_VALUEOFUINT64 define to create a buffer that is big enough.
  l | a long integer value.
  radix | the radix. Must be between RTL_STR_MIN_RADIX (2) and RTL_STR_MAX_RADIX (36), inclusive.

Returns
  the length of the string.

## ◆ rtl_string_acquire()

SAL_DLLPUBLIC void rtl_string_acquire | ( | rtl_String * | str | ) |

Increment the reference count of a string.

Parameters

  str | a string.

## ◆ rtl_string_alloc()

SAL_DLLPUBLIC rtl_String * rtl_string_alloc | ( | sal_Int32 | nLen | ) |

Allocate a new string containing space for a given number of characters.

The reference count of the new string will be 1. The length of the string will be nLen. This function does not handle out-of-memory conditions.

For failed allocation this method returns NULL.

The characters of the capacity are not cleared, and the length is set to nLen, unlike the similar method of rtl_String_new_WithLength which zeros out the buffer, and sets the length to 0. So should be somewhat more efficient for allocating a new string.

call rtl_String_release to release the string alternatively pass ownership to an OUString with rtl::OUString(newStr, SAL_NO_ACQUIRE);

Parameters

  [out] | nLen | the number of characters. Must be >= 0.

Returns
  pointer to the new string.

Since
  LibreOffice 4.1

## ◆ rtl_string_assign()

SAL_DLLPUBLIC void rtl_string_assign | ( | rtl_String ** | str,
|  | rtl_String * | rightValue )

Assign a new value to a string.

First releases any value str might currently hold, then acquires rightValue.

Parameters

  str | pointer to the string. The pointed-to data must be null or a valid string.
  rightValue | a valid string.

## ◆ rtl_string_ensureCapacity()

SAL_DLLPUBLIC void rtl_string_ensureCapacity | ( | rtl_String ** | str,
|  | sal_Int32 | size )

Ensure a string has enough space for a given number of characters.

If the given string is large enough and has refcount of 1, it is not altered in any way. Otherwise it is replaced by a copy that has enough space for the given number of characters, data from the source string is copied to the beginning of it, the content of the remaining capacity undefined, the string has refcount of 1, and refcount of the original string is decreased.

Parameters

  str | pointer to the string. The pointed-to data must be a valid string.
  size | the number of characters

Since
  LibreOffice 4.1

## ◆ rtl_string_getLength()

SAL_DLLPUBLIC sal_Int32 rtl_string_getLength | ( | const rtl_String * | str | ) |

Return the length of a string.

The length is equal to the number of characters in the string.

Parameters

  str | a valid string.

Returns
  the length of the string.

## ◆ rtl_string_getStr()

SAL_DLLPUBLIC char * rtl_string_getStr | ( | rtl_String * | str | ) |

Return a pointer to the underlying character array of a string.

Parameters

  str | a valid string.

Returns
  a pointer to the null-terminated character array.

## ◆ rtl_string_getToken()

SAL_DLLPUBLIC sal_Int32 rtl_string_getToken | ( | rtl_String ** | newStr,
|  | rtl_String * | str,
|  | sal_Int32 | token,
|  | char | cTok,
|  | sal_Int32 | idx )

Create a new string by extracting a single token from another string.

Starting at index, the next token is searched for. If there is no such token, the result is an empty string. Otherwise, all characters from the start of that token and up to, but not including the next occurrence of cTok make up the resulting token. The return value is the position of the next token, or -1 if no more tokens follow.

Example code could look like rtl_String * pToken = NULL; sal_Int32 nIndex = 0; do { ... nIndex = rtl_string_getToken(&pToken, pStr, 0, ';', nIndex); ... } while (nIndex >= 0);

The new string does not necessarily have a reference count of 1, so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string. If either token or index is negative, an empty token is stored in newStr (and -1 is returned).
  str | a valid string.
  token | the number of the token to return, starting at index.
  cTok | the character that separates the tokens.
  idx | the position at which searching for the token starts. Must not be greater than the length of str.

Returns
  the index of the next token, or -1 if no more tokens follow.

## ◆ rtl_string_new()

SAL_DLLPUBLIC void rtl_string_new | ( | rtl_String ** | newStr | ) |

Allocate a new string containing no characters.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.

## ◆ rtl_string_new_WithLength()

SAL_DLLPUBLIC void rtl_string_new_WithLength | ( | rtl_String ** | newStr,
|  | sal_Int32 | len )

Allocate a new string containing space for a given number of characters.

If len is greater than zero, the reference count of the new string will be

1. The values of all characters are set to 0 and the length of the string is 0. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  len | the number of characters.

## ◆ rtl_string_newConcat()

SAL_DLLPUBLIC void rtl_string_newConcat | ( | rtl_String ** | newStr,
|  | rtl_String * | left,
|  | rtl_String * | right )

Create a new string that is the concatenation of two other strings.

The new string does not necessarily have a reference count of 1 (in cases where one of the two other strings is empty), so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  left | a valid string.
  right | a valid string.

## ◆ rtl_string_newFromLiteral()

SAL_DLLPUBLIC void rtl_string_newFromLiteral | ( | rtl_String ** | newStr,
|  | const char * | value,
|  | sal_Int32 | len,
|  | sal_Int32 | allocExtra )

## ◆ rtl_string_newFromStr()

SAL_DLLPUBLIC void rtl_string_newFromStr | ( | rtl_String ** | newStr,
|  | const char * | value )

Allocate a new string that contains a copy of a character array.

If the length of value is greater than zero, the reference count of the new string will be 1. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  value | a null-terminated character array.

## ◆ rtl_string_newFromStr_WithLength()

SAL_DLLPUBLIC void rtl_string_newFromStr_WithLength | ( | rtl_String ** | newStr,
|  | const char * | value,
|  | sal_Int32 | len )

Allocate a new string that contains a copy of a character array.

If the length of value is greater than zero, the reference count of the new string will be 1. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  value | a character array. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the character array.

## ◆ rtl_string_newFromString()

SAL_DLLPUBLIC void rtl_string_newFromString | ( | rtl_String ** | newStr,
|  | const rtl_String * | value )

Allocate a new string that contains a copy of another string.

If the length of value is greater than zero, the reference count of the new string will be 1. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  value | a valid string.

## ◆ rtl_string_newFromSubString()

SAL_DLLPUBLIC void rtl_string_newFromSubString | ( | rtl_String ** | newStr,
|  | const rtl_String * | from,
|  | sal_Int32 | beginIndex,
|  | sal_Int32 | count )

Allocate a new string that is a substring of this string.

The substring begins at the specified beginIndex and contains count characters. Meaningless combinations such as negative beginIndex, or beginIndex + count greater than the length of the string have undefined behaviour.

Parameters

  [out] | newStr | the specified substring.
  [in] | from | the String to take the substring from.
  [in] | beginIndex | the beginning index, inclusive.
  [in] | count | the number of characters.

Since
  LibreOffice 4.0

## ◆ rtl_string_newReplace()

SAL_DLLPUBLIC void rtl_string_newReplace | ( | rtl_String ** | newStr,
|  | rtl_String * | str,
|  | char | oldChar,
|  | char | newChar )

Create a new string by replacing all occurrences of a single character within another string.

The new string results from replacing all occurrences of oldChar in str with newChar.

The new string does not necessarily have a reference count of 1 (in cases where oldChar does not occur in str), so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a valid string.
  oldChar | the old character.
  newChar | the new character.

## ◆ rtl_string_newReplaceAll()

SAL_DLLPUBLIC void rtl_string_newReplaceAll | ( | rtl_String ** | newStr,
|  | rtl_String * | str,
|  | char const * | from,
|  | sal_Int32 | fromLength,
|  | char const * | to,
|  | sal_Int32 | toLength )

Create a new string by replacing all occurrences of a given substring with another substring.

Replacing subsequent occurrences picks up only after a given replacement. That is, replacing from "xa" to "xx" in "xaa" results in "xxa", not "xxx".

Parameters

  [in,out] | newStr | pointer to the new string; must not be null; must point to null or a valid rtl_String
  | str | pointer to the original string; must not be null
  | from | pointer to the substring to be replaced; must not be null and must point to memory of at least `fromLength` bytes
  | fromLength | the length of the `from` substring; must be non-negative
  | to | pointer to the replacing substring; must not be null and must point to memory of at least `toLength` bytes
  | toLength | the length of the `to` substring; must be non-negative

Since
  LibreOffice 3.6

## ◆ rtl_string_newReplaceFirst()

SAL_DLLPUBLIC void rtl_string_newReplaceFirst | ( | rtl_String ** | newStr,
|  | rtl_String * | str,
|  | char const * | from,
|  | sal_Int32 | fromLength,
|  | char const * | to,
|  | sal_Int32 | toLength,
|  | sal_Int32 * | index )

Create a new string by replacing the first occurrence of a given substring with another substring.

Parameters

  [in,out] | newStr | pointer to the new string; must not be null; must point to null or a valid rtl_String
  | str | pointer to the original string; must not be null
  | from | pointer to the substring to be replaced; must not be null and must point to memory of at least `fromLength` bytes
  | fromLength | the length of the `from` substring; must be non-negative
  | to | pointer to the replacing substring; must not be null and must point to memory of at least `toLength` bytes
  | toLength | the length of the `to` substring; must be non-negative
  [in,out] | index | pointer to a start index, must not be null; upon entry to the function its value is the index into the original string at which to start searching for the `from` substring, the value must be non-negative and not greater than the original string's length; upon exit from the function its value is the index into the original string at which the replacement took place or -1 if no replacement took place

Since
  LibreOffice 3.6

## ◆ rtl_string_newReplaceStrAt()

SAL_DLLPUBLIC void rtl_string_newReplaceStrAt | ( | rtl_String ** | newStr,
|  | rtl_String * | str,
|  | sal_Int32 | idx,
|  | sal_Int32 | count,
|  | rtl_String * | subStr )

Create a new string by replacing a substring of another string.

The new string results from replacing a number of characters (count), starting at the specified position (index) in the original string (str), with some new substring (subStr). If subStr is null, then only a number of characters is deleted.

The new string does not necessarily have a reference count of 1, so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a valid string.
  idx | the index into str at which to start replacement. Must be between 0 and the length of str, inclusive.
  count | the number of characters to remove. Must not be negative, and the sum of index and count must not exceed the length of str.
  subStr | either null or a valid string to be inserted.

## ◆ rtl_string_newToAsciiLowerCase()

SAL_DLLPUBLIC void rtl_string_newToAsciiLowerCase | ( | rtl_String ** | newStr,
|  | rtl_String * | str )

Create a new string by converting all ASCII uppercase letters to lowercase within another string.

The new string results from replacing all characters with values between 65 and 90 (ASCII A–Z) by values between 97 and 122 (ASCII a–z).

This function cannot be used for language-specific conversion. The new string does not necessarily have a reference count of 1 (in cases where no characters need to be converted), so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a valid string.

## ◆ rtl_string_newToAsciiUpperCase()

SAL_DLLPUBLIC void rtl_string_newToAsciiUpperCase | ( | rtl_String ** | newStr,
|  | rtl_String * | str )

Create a new string by converting all ASCII lowercase letters to uppercase within another string.

The new string results from replacing all characters with values between 97 and 122 (ASCII a–z) by values between 65 and 90 (ASCII A–Z).

This function cannot be used for language-specific conversion. The new string does not necessarily have a reference count of 1 (in cases where no characters need to be converted), so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a valid string.

## ◆ rtl_string_newTrim()

SAL_DLLPUBLIC void rtl_string_newTrim | ( | rtl_String ** | newStr,
|  | rtl_String * | str )

Create a new string by removing white space from both ends of another string.

The new string results from removing all characters with values less than or equal to 32 (the space character) form both ends of str.

This function cannot be used for language-specific conversion. The new string does not necessarily have a reference count of 1 (in cases where no characters need to be removed), so it must not be modified without checking the reference count. This function does not handle out-of-memory conditions.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a valid string.

## ◆ rtl_string_release()

SAL_DLLPUBLIC void rtl_string_release | ( | rtl_String * | str | ) |

Decrement the reference count of a string.

If the count goes to zero than the string data is deleted.

Parameters

  str | a string.

## ◆ rtl_uString2String()

SAL_DLLPUBLIC void rtl_uString2String | ( | rtl_String ** | newStr,
|  | const sal_Unicode * | str,
|  | sal_Int32 | len,
|  | rtl_TextEncoding | encoding,
|  | sal_uInt32 | convertFlags )

Create a new byte string by converting a Unicode string, using a specific text encoding.

The lengths of the byte string and the Unicode string may differ (e.g., for double-byte encodings, UTF-7, UTF-8).

If the length of the Unicode string is greater than zero, the reference count of the new string will be 1.

If an out-of-memory condition occurs, newStr will point to a null pointer upon return.

Parameters

  newStr | pointer to the new string. The pointed-to data must be null or a valid string.
  str | a Unicode character array. Need not be null-terminated, but must be at least as long as the specified len.
  len | the length of the Unicode character array.
  encoding | the text encoding to use for conversion.
  convertFlags | flags which control the conversion. Either use OUSTRING_TO_OSTRING_CVTFLAGS, or see http://udk.openoffice.org/cpp/man/spec/textconversion.html for more details.